After the success of 2nd anniversary (take a look at problem FTOUR for more details), this 3rd year, Travel Agent SPOJ goes on with another discount tour.

The tour will be held on ICPC island, a miraculous one on the Pacific Ocean. We list N places (indexed from 1 to N) where the visitors can have a trip. Each road connecting them has an interest value, and this value can be negative (if there is nothing interesting to view there). Simply, these N places along with the roads connecting them form a tree structure. We will choose two places as the departure and destination of the tour.

Since September is the festival season of local inhabitants, some places are extremely crowded (we call them crowded places). Therefore, the organizer of the excursion hopes the tour will visit at most K crowded places (too tiring to visit many of them) and of course, the total number of interesting value should be maximum.

Briefly, you are given a map of N places, an integer K, and M id numbers of crowded place. Please help us to find the optimal tour. Note that we can visit each place only once (or our customers easily feel bored), also the departure and destination places don't need to be different.

Input

There is exactly one case. First one line, containing 3 integers N K M, with 1 <= N <= 200000, 0 <= K <= M, 0 <= M <= N.

Next M lines, each line includes an id number of a crowded place.

The last (N - 1) lines describe (N - 1) two-way roads connected N places, form a b i, with a, b is the id of 2 places, and i is its interest value (-10000 <= i <= 10000).

Output

Only one number, the maximum total interest value we can obtain.

Example

Input:
8 2 3
3
5
7
1 3 1
2 3 10
3 4 -2
4 5 -1
5 7 6
5 6 5
4 8 3 Output:
12

Explanation

We choose 2 and 6 as the departure and destination place, so the tour will be 2 -> 3 -> 4 -> 5 -> 6, total interest value = 10 + (-2) + (-1) + 5 = 12
* Added some unofficial case

题解:

设路径起点为根,终点为x的路径,经过黑色结点数量为deep[x],路径长度为dis[x]
考虑解决经过根的路径,递归子树处理其它路径。
依次处理root的每棵子树,处理到子树S的时候,我们需要知道出发点为根,终点在前S-1棵子树子树中,经过t(t<K)个黑点的路径的最长长度,记为mx[t]
则对于子树S的结点x

    mx[t]+dis[x](deep[x]+t<=k)-->ans

mx[t]+dis[x](deep[x]+t≤K)−→−−−updateans


(若根为黑色处理时将K–,处理完恢复)若按照deep倒序处理每个结点,mx指针now按照升序扫,mx[now-1]---> mx[now]mx[now−1]−→−−−updatemx[now]

这样就能得到符合条件的mx[t]的最大值。
然后再考虑用子树S的信息更新mx,将两个数组合并的操作次数max[L1,L2]

可以考虑按照每棵子树deep的升序依次合并子树。从总体来看,由于总边数是n-1,则排序的复杂度nlogn,同时这样启发式合并使得合并的复杂度降为nlogn

参考代码:

#include<bits/stdc++.h>
using namespace std;
#define PI acos(-1.0)
#define pii pair<int,int>
#define mkp make_pair
#define pb push_back
#define fi first
#define se second
#define mod 1000000007
typedef long long ll;
const int INF=0x3f3f3f3f;
const ll inf=0x3f3f3f3f3f3f3f3fll;
inline int read()
{
int x=,f=; char ch=getchar();
while(ch<''||ch>''){if(ch=='-')f=-;ch=getchar();}
while(ch>=''&&ch<=''){x=x*+ch-'';ch=getchar();}
return x*f;
} const int maxn=2e5+;
int n,m,k,cnt,rt,sum,mx_dep,ans;
int dis[maxn],f[maxn],mx[maxn],tmp[maxn];
int head[maxn],vis[maxn],siz[maxn];
int col[maxn],deep[maxn];
vector<pii> vec; struct Edge{
int v,w,nxt;
} edge[maxn<<]; void addedge(int u,int v,int w)
{
edge[cnt].v=v;
edge[cnt].w=w;
edge[cnt].nxt=head[u];
head[u]=cnt++;
} void getroot(int x,int fa)
{
siz[x]=;f[x]=;
for(int i=head[x];~i;i=edge[i].nxt)
{
int v=edge[i].v;
if(v!=fa && !vis[v])
{
getroot(v,x);
f[x]=max(f[x],siz[v]);
siz[x]+=siz[v];
}
}
f[x]=max(f[x],sum-siz[x]);
if(f[x]<f[rt]) rt=x;
} void getdis(int x,int fa)
{
mx_dep=max(mx_dep,deep[x]);
for(int i=head[x];~i;i=edge[i].nxt)
{
int v=edge[i].v;
if(!vis[v] && v!=fa)
{
deep[v]=deep[x]+col[v];
dis[v]=dis[x]+edge[i].w;
getdis(v,x);
}
}
} void getmx(int x,int fa)
{
tmp[deep[x]]=max(tmp[deep[x]],dis[x]);
for(int i=head[x];~i;i=edge[i].nxt)
{
int v=edge[i].v;
if(!vis[v] && v!=fa) getmx(v,x);
}
} void solve(int x,int S)
{
vis[x]=; vec.clear();
if(col[x]) --k;
for(int i=head[x];~i;i=edge[i].nxt)
{
if(!vis[edge[i].v])
{
mx_dep=;
deep[edge[i].v]=col[edge[i].v];
dis[edge[i].v]=edge[i].w;
getdis(edge[i].v,x);
vec.pb(mkp(mx_dep,edge[i].v));
}
} sort(vec.begin(),vec.end()); for(int i=,t=vec.size();i<t;++i)
{
getmx(vec[i].se,x);
int now=;
if(i!=)
{
for(int j=vec[i].fi;j>=;--j)
{
while(now+j<k && now<vec[i-].fi)
++now,mx[now]=max(mx[now],mx[now-]);
if(now+j<=k) ans=max(ans,tmp[j]+mx[now]);
}
}
if(i!=t-)
{
for(int j=,ct=vec[i].fi;j<=ct;++j)
mx[j]=max(mx[j],tmp[j]),tmp[j]=;
}
else
{
for(int j=,ct=vec[i].fi;j<=ct;++j)
{
if(j<=k) ans=max(ans,max(mx[j],tmp[j]));
tmp[j]=mx[j]=;
}
}
} if(col[x]) ++k; for(int i=head[x];~i;i=edge[i].nxt)
{
if(!vis[edge[i].v])
{
rt=;
sum=siz[edge[i].v];
if(siz[edge[i].v]>siz[x]) sum=S-siz[x];
getroot(edge[i].v,x);
solve(rt,sum);
}
}
} int main()
{
n=read();k=read();m=read();
int color,x,y,z;
ans=mx_dep=cnt=; sum=n; f[]=n;
memset(head,-,sizeof(head));
memset(vis,,sizeof(vis));
memset(col,,sizeof(col)); for(int i=;i<=m;++i) color=read(),col[color]=;
for(int i=;i<n;++i)
{
x=read();y=read();z=read();
addedge(x,y,z);
addedge(y,x,z);
} getroot(,);
solve(rt,sum); printf("%d\n",ans); return ;
}

SPOJ Free TourII(点分治+启发式合并)的更多相关文章

  1. SPOJ:Free tour II (树分治+启发式合并)

    After the success of 2nd anniversary (take a look at problem FTOUR for more details), this 3rd year, ...

  2. SP1825 FTOUR2 - Free tour II 点分治+启发式合并+未调完

    题意翻译 给定一棵n个点的树,树上有m个黑点,求出一条路径,使得这条路径经过的黑点数小于等于k,且路径长度最大 Code: #include <bits/stdc++.h> using n ...

  3. CodeForces 958F3 Lightsabers (hard) 启发式合并/分治 多项式 FFT

    原文链接http://www.cnblogs.com/zhouzhendong/p/8835443.html 题目传送门 - CodeForces 958F3 题意 有$n$个球,球有$m$种颜色,分 ...

  4. 【题解】P4755 Beautiful Pair(启发式合并的思路+分治=启发式分治)

    [题解]P4755 Beautiful Pair upd: 之前一个first second烦了,现在AC了 由于之前是直接抄std写的,所以没有什么心得体会,今天自己写写发现 不知道为啥\(90\) ...

  5. P5979 [PA2014]Druzyny dp 分治 线段树 分类讨论 启发式合并

    LINK:Druzyny 这题研究了一下午 终于搞懂了. \(n^2\)的dp很容易得到. 考虑优化.又有大于的限制又有小于的限制这个非常难处理. 不过可以得到在限制人数上界的情况下能转移到的最远端点 ...

  6. CF932F Escape Through Leaf 斜率优化、启发式合并

    传送门 \(DP\) 设\(f_i\)表示第\(i\)个节点的答案,\(S_i\)表示\(i\)的子节点集合,那么转移方程为\(f_i = \min\limits_{j \in S_i} \{a_i ...

  7. [2016北京集训试题7]thr-[树形dp+树链剖分+启发式合并]

    Description Solution 神仙操作orz. 首先看数据范围,显然不可能是O(n2)的.(即绝对不是枚举那么简单的),我们考虑dp. 定义f(x,k)为以x为根的子树中与x距离为k的节点 ...

  8. 【20181026T2】**图【最小瓶颈路+非旋Treap+启发式合并】

    题面 [错解] 最大最小?最小生成树嘛 蛤?还要求和? 点分治? 不可做啊 写了个MST+暴力LCA,30pts,140多行 事后发现30分是给dijkstra的 woc [正解] 树上计数问题:①并 ...

  9. 【主席树启发式合并】【P3302】[SDOI2013]森林

    Description 给定一个 \(n\) 个节点的森林,有 \(Q\) 次操作,每次要么将森林中某两点联通,保证操作后还是个森林,要么查询两点间权值第 \(k\) 小,保证两点联通.强制在线. L ...

随机推荐

  1. 可保图片不变形的object-fit

    Object-fit 我们有时候浏览一些网站的时候,偶尔会遇到这种情况:  明显它喵的形变了,尤其是这种这么业余的失误,还是出现在一个专门做图片的网站上. 产生这种现象的原因是:图片写了固定的宽高,这 ...

  2. Pandas进阶笔记 (一) Groupby 重难点总结

    如果Pandas只是能把一些数据变成 dataframe 这样优美的格式,那么Pandas绝不会成为叱咤风云的数据分析中心组件.因为在数据分析过程中,描述数据是通过一些列的统计指标实现的,分析结果也需 ...

  3. js正则匹配的出链接地址

    content为需要匹配的值 var b=/<a([\s]+|[\s]+[^<>]+[\s]+)href=(\"([^<>"\']*)\"| ...

  4. 接口测试专题(Java & jmeter & Linux基础)

    以下是我和两个朋友原创文章合集,主题是接口测试,有Java接口测试案例和jmeter的案例,还有接口测试相关服务器操作基础.欢迎点赞.关注和转发. 接口测试 httpclient处理多用户同时在线 h ...

  5. Jsp自学2

    Jsp简单来说就是java代码与Html代码的组合,类,方法,属性跟网页展示夹杂在一起.Jsp就是Servlet,但比Servle简单,不需要配置web.xml(当然也可以配置).Jsp由模板数据与元 ...

  6. Ubuntu清空回收站

    ubuntu 回收站的具体位置:$HOME/.local/share/Trash/ 执行如下命令清空回收站: sudo rm -fr $HOME/.local/share/Trash/files/ 如 ...

  7. nyoj 1112 求次数 (map)

    求次数 时间限制:1000 ms  |  内存限制:65535 KB 难度:2   描述 题意很简单,给一个数n 以及一个字符串str,区间[i,i+n-1] 为一个新的字符串,i 属于[0,strl ...

  8. 领扣(LeetCode)两个列表的最小索引总和 个人题解

    假设Andy和Doris想在晚餐时选择一家餐厅,并且他们都有一个表示最喜爱餐厅的列表,每个餐厅的名字用字符串表示. 你需要帮助他们用最少的索引和找出他们共同喜爱的餐厅. 如果答案不止一个,则输出所有答 ...

  9. Vue导入非模块化的第三方插件功能无效解决方案

    一.问题: 最近在写vue项目时,想引入某些非模块化的第三方插件时,总是发现会有报错.且在与本地运行插件测试对比时发现插件根本没有注入到jQuery中(console.log($.fn)查看当前jq有 ...

  10. Linux定时任务 crontab(-l -e)、at、batch

    1.周期性定时任务crontab cron['krɒn] 一时间单位  table crontab -e 进入编辑定时任务界面,每一行代表一个定时任务,#开头的行为注释行,一行分成6列 分钟 小时 日 ...